Index: c/src/lib/libbsp/i386/i386ex/clock/ckinit.c
===================================================================
--- c/src/lib/libbsp/i386/i386ex/clock/ckinit.c	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/i386ex/clock/ckinit.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -78,5 +78,5 @@
 }
 
-static rtems_irq_connect_data clockIrqData = {PC_386_PERIODIC_TIMER,
+static rtems_irq_connect_data clockIrqData = {BSP_PERIODIC_TIMER,
 					      Clock_isr,
 					      ClockOn,
@@ -115,5 +115,5 @@
   outport_byte  ( TMR0   , clock_msb );  /* then MSB       */
  
-  if (!pc386_install_rtems_irq_handler (&clockIrqData)) {
+  if (!BSP_install_rtems_irq_handler (&clockIrqData)) {
     printk("Unable to initialize system clock\n");
     rtems_fatal_error_occurred(1);
@@ -152,5 +152,5 @@
     else if (args->command == rtems_build_name('N', 'E', 'W', ' '))
     {
-      if (!pc386_install_rtems_irq_handler (&clockIrqData)) {
+      if (!BSP_install_rtems_irq_handler (&clockIrqData)) {
 	printk("Error installing clock interrupt handler!\n");
 	rtems_fatal_error_occurred(1);
@@ -169,4 +169,4 @@
 {
   ClockOff(&clockIrqData);  
-  pc386_remove_rtems_irq_handler (&clockIrqData);
+  BSP_remove_rtems_irq_handler (&clockIrqData);
 }
Index: c/src/lib/libbsp/i386/i386ex/console/console.c
===================================================================
--- c/src/lib/libbsp/i386/i386ex/console/console.c	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/i386ex/console/console.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -1,295 +1,401 @@
+/*-------------------------------------------------------------------------+
+| console.c v1.1 - i386ex BSP - 1997/08/07
++--------------------------------------------------------------------------+
+| This file contains the i386ex console I/O package. It is just a termios 
+| wrapper.
++--------------------------------------------------------------------------+
+| (C) Copyright 1997 -
+| - NavIST Group - Real-Time Distributed Systems and Industrial Automation
+|
+| http://pandora.ist.utl.pt
+|
+| Instituto Superior Tecnico * Lisboa * PORTUGAL
++--------------------------------------------------------------------------+
+| Disclaimer:
+|
+| This file is provided "AS IS" without warranty of any kind, either
+| expressed or implied.
++--------------------------------------------------------------------------+
+| This code is based on:
+|   console.c,v 1.4 1995/12/19 20:07:23 joel Exp - go32 BSP
+|   console.c,v 1.15 pc386 BSP
+| With the following copyright notice:
+| **************************************************************************
+| *  COPYRIGHT (c) 1989-1998.
+| *  On-Line Applications Research Corporation (OAR).
+| *  Copyright assigned to U.S. Government, 1994. 
+| *
+| *  The license and distribution terms for this file may be
+| *  found in found in the file LICENSE in this distribution or at
+| *  http://www.OARcorp.com/rtems/license.html.
+| **************************************************************************
+|
+|  $Id$
++--------------------------------------------------------------------------*/
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <assert.h>
+
+/* workaround for gcc development tools */
+#undef __assert
+void __assert (const char *file, int line, const char *msg);
+
+#include <bsp.h>
+#include <irq.h>
+#include <rtems/libio.h>
+#include <termios.h>
+#include <uart.h>
+#include <libcpu/cpuModel.h>
+
 /*
- *  This file contains the i386ex console IO package.
- *
- *  COPYRIGHT (c) 1989-1998.
- *  On-Line Applications Research Corporation (OAR).
- *  Copyright assigned to U.S. Government, 1994.
- *
- *  The license and distribution terms for this file may be
- *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
- *
- *  $Id$
+ * Possible value for console input/output :
+ *	BSP_UART_COM1
+ *	BSP_UART_COM2
+ *  BSP_CONSOLE_PORT_CONSOLE is not valid in this BSP.  
+ *      All references to either keyboard or video handling have been removed.
  */
 
-#define F386_INIT
-
-#include <bsp.h>
-#include <rtems/libio.h>
-#include <bspIo.h>
-#include <stdlib.h>
-
-#include "../start/80386ex.h"
-
-/*  console_cleanup
- *
- *  This routine is called at exit to clean up the console hardware.
- *
- *  Input parameters: NONE
- *
- *  Output parameters:  NONE
- *
- *  Return values:
+int BSPConsolePort = BSP_UART_COM2;
+int BSPBaseBaud    = 781250;
+int BSP_poll_read(int);
+
+extern BSP_polling_getchar_function_type BSP_poll_char;
+
+static int  conSetAttr(int minor, const struct termios *);
+static void isr_on(const rtems_irq_connect_data *);
+static void isr_off(const rtems_irq_connect_data *);
+static int  isr_is_on(const rtems_irq_connect_data *);
+
+/*
+ * Change references to com2 if required.
  */
 
-void console_cleanup( void )
-{
-  register rtems_unsigned8 ignored;
-
-/* clear the read buffer */
-
-   inport_byte( RBR0, ignored );
-
-}
-
-/*  console_initialize
- *
- *  This routine initializes the console IO driver.
- *
- *  Input parameters: NONE
- *
- *  Output parameters:  NONE
- *
- *  Return values:
- */
-
-rtems_device_driver console_initialize(
-  rtems_device_major_number  major,
-  rtems_device_minor_number  minor,
-  void                      *arg
-)
+static rtems_irq_connect_data console_isr_data = 
+{ BSP_UART_COM2_IRQ,
+  BSP_uart_termios_isr_com2,
+  isr_on,
+  isr_off,
+  isr_is_on};
+
+static void
+isr_on(const rtems_irq_connect_data *unused)
+{
+  return;
+}
+						   
+static void
+isr_off(const rtems_irq_connect_data *unused)
+{
+  return;
+}
+
+static int
+isr_is_on(const rtems_irq_connect_data *irq)
+{
+  return BSP_irq_enabled_at_i8259s(irq->name);
+}
+
+void console_reserve_resources(rtems_configuration_table *conf)
+{
+  rtems_termios_reserve_resources(conf, 1);
+  return;
+}
+
+void __assert (const char *file, int line, const char *msg)
+{
+    static   char exit_msg[] = "EXECUTIVE SHUTDOWN! Any key to reboot...";
+  unsigned char  ch;
+   
+  /*
+   * Note we cannot call exit or printf from here, 
+   * assert can fail inside ISR too
+   */
+
+   /*
+   * Close console
+   */
+  __rtems_close(2);
+  __rtems_close(1);
+  __rtems_close(0);
+
+  printk("\nassert failed: %s: ", file);
+  printk("%d: ", line);
+  printk("%s\n\n", msg);
+  printk(exit_msg);
+  ch = BSP_poll_char();
+  printk("\nShould jump to reset now!\n");
+}
+
+
+/*-------------------------------------------------------------------------+
+| Console device driver INITIALIZE entry point.
++--------------------------------------------------------------------------+
+| Initilizes the I/O console (keyboard + VGA display) driver.
++--------------------------------------------------------------------------*/
+rtems_device_driver
+console_initialize(rtems_device_major_number major,
+                   rtems_device_minor_number minor,
+                   void                      *arg)
 {
   rtems_status_code status;
 
   /*
-   *  flush the console now and at exit.  Just in case.
-   */
-
-  console_cleanup();
-
-  status = rtems_io_register_name(
-    "/dev/console",
-    major,
-    (rtems_device_minor_number) 0
-  );
+   * Set up TERMIOS
+   */
+  rtems_termios_initialize ();
+  
+  /*
+   * Do device-specific initialization
+   */
+  
+  /* 9600-8-N-1, no hardware flow control */
+  BSP_uart_init(BSPConsolePort, 9600, 0);
+  
+  
+  /* Set interrupt handler */
+  if(BSPConsolePort == BSP_UART_COM1)
+    {
+      console_isr_data.name = BSP_UART_COM1_IRQ;
+      console_isr_data.hdl  = BSP_uart_termios_isr_com1;
+      
+    }
+  else
+    {
+      assert(BSPConsolePort == BSP_UART_COM2);
+      console_isr_data.name = BSP_UART_COM2_IRQ;
+      console_isr_data.hdl  = BSP_uart_termios_isr_com2;
+    }
+  
+  status = BSP_install_rtems_irq_handler(&console_isr_data);
+  
+  if (!status){
+    printk("Error installing serial console interrupt handler!\n");
+    rtems_fatal_error_occurred(status);
+  }
+  /*
+   * Register the device
+   */
+  status = rtems_io_register_name ("/dev/console", major, 0);
+  if (status != RTEMS_SUCCESSFUL)
+    {
+      printk("Error registering console device!\n");
+      rtems_fatal_error_occurred (status);
+    }
+  
+  if(BSPConsolePort == BSP_UART_COM1)
+    {
+      printk("Initialized console on port COM1 9600-8-N-1\n\n");
+    }
+  else
+    {
+      printk("Initialized console on port COM2 9600-8-N-1\n\n");
+    }
+
+  return RTEMS_SUCCESSFUL;
+} /* console_initialize */
+
+
+static int console_open_count = 0;
+
+static int console_last_close(int major, int minor, void *arg)
+{
+  BSP_remove_rtems_irq_handler (&console_isr_data);
+
+  return 0;
+}
+
+/*-------------------------------------------------------------------------+
+| Console device driver OPEN entry point
++--------------------------------------------------------------------------*/
+rtems_device_driver
+console_open(rtems_device_major_number major,
+                rtems_device_minor_number minor,
+                void                      *arg)
+{
+  rtems_status_code              status;
+  static rtems_termios_callbacks cb = 
+  {
+    NULL,	              /* firstOpen */
+    console_last_close,       /* lastClose */
+    NULL,                     /* poll read  */
+    BSP_uart_termios_write_com2, /* write */
+    conSetAttr,	              /* setAttributes */
+    NULL,	              /* stopRemoteTx */
+    NULL,	              /* startRemoteTx */
+    1		              /* outputUsesInterrupts */
+  };
+
+  if(BSPConsolePort == BSP_UART_COM2)
+    {
+      cb.write = BSP_uart_termios_write_com2;
+    }
+
+  status = rtems_termios_open (major, minor, arg, &cb);
+
+  if(status != RTEMS_SUCCESSFUL)
+    {
+      printk("Error openning console device\n");
+      return status;
+    }
+
+  /*
+   * Pass data area info down to driver
+   */
+  BSP_uart_termios_set(BSPConsolePort, 
+			 ((rtems_libio_open_close_args_t *)arg)->iop->data1);
+  
+  /* Enable interrupts  on channel */
+  BSP_uart_intr_ctrl(BSPConsolePort, BSP_UART_INTR_CTRL_TERMIOS);
+
+  return RTEMS_SUCCESSFUL;
+}
+
+/*-------------------------------------------------------------------------+
+| Console device driver CLOSE entry point
++--------------------------------------------------------------------------*/
+rtems_device_driver
+console_close(rtems_device_major_number major,
+              rtems_device_minor_number minor,
+              void                      *arg)
+{
+
+  return (rtems_termios_close (arg));
+  
+} /* console_close */
+
  
-  if (status != RTEMS_SUCCESSFUL)
-    rtems_fatal_error_occurred(status);
+/*-------------------------------------------------------------------------+
+| Console device driver READ entry point.
++--------------------------------------------------------------------------+
+| Read characters from the I/O console. We only have stdin.
++--------------------------------------------------------------------------*/
+rtems_device_driver
+console_read(rtems_device_major_number major,
+             rtems_device_minor_number minor,
+             void                      *arg)
+{
+  rtems_status_code sc;
+  printf("read the console\n");
+
+  sc = rtems_termios_read (arg);
+
+  if ( sc != RTEMS_SUCCESSFUL )
+    printf("console_read: fails %s\n",rtems_status_text(sc));
+
+  return sc;
+
+} /* console_read */
  
-  atexit( console_cleanup );
-
-  return RTEMS_SUCCESSFUL;
-}
-
-
-/*  is_character_ready
- *
- *  This routine returns TRUE if a character is available.
- *
- *  Input parameters: NONE
- *
- *  Output parameters:  NONE
- *
- *  Return values:
- */
-
-rtems_boolean is_character_ready(
-  char *ch
-)
-{
-  register rtems_unsigned8 status;
-
-  inport_byte( LSR1, status );
-
-  if ( Is_rx_ready( status ) ) {
-     inport_byte( RBR1,  status );
-     *ch = status;
-     return TRUE;
-  }
-  return FALSE;
-}
-
-/*
- * Wait for an input. May be used before  intr are ON.
- */
-char BSP_wait_polled_input( void )
-{
-  char c;
-  while (!is_character_ready(&c))
-    continue;
-
-  return c;
-}
-     
-/*  inbyte
- *
- *  This routine reads a character from the UART.
- *
- *  Input parameters: NONE
- *
- *  Output parameters:  NONE
- *
- *  Return values:
- *    character read from UART
- */
-
-char inbyte( void )
-{
-  register rtems_unsigned8 status; 
-  char                     ch;
-
-  do {
-    inport_byte( LSR1, status );
-  } while ( !( status & 0x01 ));/* s/b while ( !( Is_rx_ready( status ) ) ); */
-
-  inport_byte( RBR1, ch );
-
-  return ch;
-}
-
-/*  outbyte
- *
- *  This routine transmits a character out the port.  It supports
- *  XON/XOFF flow control.
- *
- *  Input parameters:
- *    ch  - character to be transmitted
- *
- *  Output parameters:  NONE
- */
-
-void outbyte(
-  char ch
-)
-{
-  rtems_unsigned8 status;
-
-  do {
-    inport_byte( LSR1, status );
-  } while ( ! ( 0x40 & status ) ); /* ( Is_tx_ready( status ) ) );*/
-
-/*
- *  GDB will NOT use XON/XOFF protocol
- */
-
-
-#ifdef USE_XON
-  
-  while ( is_character_ready( &status ) == TRUE ) { 
-    if ( status == XOFF )
-      do {
-        while ( is_character_ready( &status ) == FALSE ) ;
-      } while ( status != XON );
-  }
-
-#endif
-
-  outport_byte( TBR1, ch );
-
-}
-
-/*
- *  Open entry point
- */
+
+/*-------------------------------------------------------------------------+
+| Console device driver WRITE entry point.
++--------------------------------------------------------------------------+
+| Write characters to the I/O console. Stderr and stdout are the same.
++--------------------------------------------------------------------------*/
+rtems_device_driver
+console_write(rtems_device_major_number major,
+              rtems_device_minor_number minor,
+              void                    * arg)
+{
+        return rtems_termios_write (arg);
  
-rtems_device_driver console_open(
-  rtems_device_major_number major,
-  rtems_device_minor_number minor,
-  void                    * arg
-)
-{
-  return RTEMS_SUCCESSFUL;
-}
+} /* console_write */
+
+
  
 /*
- *  Close entry point
+ * Handle ioctl request.
  */
- 
-rtems_device_driver console_close(
-  rtems_device_major_number major,
-  rtems_device_minor_number minor,
-  void                    * arg
+rtems_device_driver 
+console_control(rtems_device_major_number major,
+		rtems_device_minor_number minor,
+		void                      * arg
 )
-{
-  return RTEMS_SUCCESSFUL;
-}
- 
+{ 
+  return rtems_termios_ioctl (arg);
+}
+
+static int
+conSetAttr(int minor, const struct termios *t)
+{
+  int baud;
+
+  switch (t->c_cflag & CBAUD) 
+    {
+    case B50:	
+      baud = 50;
+      break;
+    case B75:	
+      baud = 75;	
+      break;
+    case B110:	
+      baud = 110;	
+      break;
+    case B134:	
+      baud = 134;	
+      break;
+    case B150:	
+      baud = 150;	
+      break;
+    case B200:
+      baud = 200;	
+      break;
+    case B300:	
+      baud = 300;
+      break;
+    case B600:	
+      baud = 600;	
+      break;
+    case B1200:	
+      baud = 1200;
+      break;
+    case B1800:	
+      baud = 1800;	
+      break;
+    case B2400:	
+      baud = 2400;
+      break;
+    case B4800:	
+      baud = 4800;
+      break;
+    case B9600:	
+      baud = 9600;
+      break;
+    case B19200:
+      baud = 19200;
+      break;
+    case B38400:
+      baud = 38400;
+      break;
+    case B57600:	
+      baud = 57600;
+      break;
+    case B115200:
+      baud = 115200;
+      break;
+    default:
+      baud = 0;
+      rtems_fatal_error_occurred (RTEMS_INTERNAL_ERROR);
+      return 0;
+    }
+
+  BSP_uart_set_baud(BSPConsolePort, baud);
+
+  return 0;
+}
+
 /*
- * read bytes from the serial port. We only have stdin.
+ * BSP initialization
  */
- 
-rtems_device_driver console_read(
-  rtems_device_major_number major,
-  rtems_device_minor_number minor,
-  void                    * arg
-)
-{
-  rtems_libio_rw_args_t *rw_args;
-  char *buffer;
-  int maximum;
-  int count = 0;
- 
-  rw_args = (rtems_libio_rw_args_t *) arg;
- 
-  buffer = rw_args->buffer;
-  maximum = rw_args->count;
- 
-  for (count = 0; count < maximum; count++) {
-    buffer[ count ] = inbyte();
-    if (buffer[ count ] == '\n' || buffer[ count ] == '\r') {
-      buffer[ count++ ]  = '\n';
-      break;
-    }
-  }
- 
-  rw_args->bytes_moved = count;
-  return (count >= 0) ? RTEMS_SUCCESSFUL : RTEMS_UNSATISFIED;
-}
-
-/*
- * write bytes to the serial port. Stdout and stderr are the same.
- */
- 
-rtems_device_driver console_write(
-  rtems_device_major_number major,
-  rtems_device_minor_number minor,
-  void                    * arg
-)
-{
-  int count;
-  int maximum;
-  rtems_libio_rw_args_t *rw_args;
-  char *buffer;
- 
-  rw_args = (rtems_libio_rw_args_t *) arg;
- 
-  buffer = rw_args->buffer;
-  maximum = rw_args->count;
- 
-  for (count = 0; count < maximum; count++) {
-    if ( buffer[ count ] == '\n') {
-      outbyte('\r');
-    }
-    outbyte( buffer[ count ] );
-  }
- 
-  rw_args->bytes_moved = maximum;
-  return 0;
-}
- 
-/*
- *  IO Control entry point
- */
- 
-rtems_device_driver console_control(
-  rtems_device_major_number major,
-  rtems_device_minor_number minor,
-  void                    * arg
-)
-{
-  return RTEMS_SUCCESSFUL;
-}
-
-BSP_output_char_function_type 		BSP_output_char = outbyte;
-BSP_polling_getchar_function_type 	BSP_poll_char = BSP_wait_polled_input;
-
+
+BSP_output_char_function_type BSP_output_char = 
+                       (BSP_output_char_function_type)    BSP_output_char_via_serial;
+
+BSP_polling_getchar_function_type BSP_poll_char =  
+                      (BSP_polling_getchar_function_type) BSP_poll_char_via_serial;
+
+int BSP_poll_read(int ttyMinor){
+  
+  return BSP_poll_char_via_serial();
+}
Index: c/src/lib/libbsp/i386/i386ex/timer/timer.c
===================================================================
--- c/src/lib/libbsp/i386/i386ex/timer/timer.c	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/i386ex/timer/timer.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -56,5 +56,5 @@
    * enable interrrupt at i8259 level
    */
-  pc386_irq_enable_at_i8259s(used->idtIndex - PC386_IRQ_VECTOR_BASE);
+  BSP_irq_enable_at_i8259s(used->idtIndex - BSP_IRQ_VECTOR_BASE);
 }
 
@@ -64,10 +64,10 @@
      * disable interrrupt at i8259 level
      */
-     pc386_irq_disable_at_i8259s(used->idtIndex - PC386_IRQ_VECTOR_BASE);
+     BSP_irq_disable_at_i8259s(used->idtIndex - BSP_IRQ_VECTOR_BASE);
      /* reset timer mode to standard (DOS) value */
 }
 
 static rtems_raw_irq_connect_data timer_raw_irq_data = {
-  PC_386_RT_TIMER3 + PC386_IRQ_VECTOR_BASE,
+  BSP_RT_TIMER3 + BSP_IRQ_VECTOR_BASE,
   timerisr,
   TimerOn,
Index: c/src/lib/libbsp/i386/pc386/clock/ckinit.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/clock/ckinit.c	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/pc386/clock/ckinit.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -177,5 +177,5 @@
 }
 
-static rtems_irq_connect_data clockIrqData = {PC_386_PERIODIC_TIMER,
+static rtems_irq_connect_data clockIrqData = {BSP_PERIODIC_TIMER,
 					      clockIsr,
 					      clockOn,
@@ -196,5 +196,5 @@
 {
 
-  if (!pc386_install_rtems_irq_handler (&clockIrqData)) {
+  if (!BSP_install_rtems_irq_handler (&clockIrqData)) {
     printk("Unable to initialize system clock\n");
     rtems_fatal_error_occurred(1);
@@ -230,5 +230,5 @@
     else if (args->command == rtems_build_name('N', 'E', 'W', ' '))
     {
-      if (!pc386_install_rtems_irq_handler (&clockIrqData)) {
+      if (!BSP_install_rtems_irq_handler (&clockIrqData)) {
 	printk("Error installing clock interrupt handler!\n");
 	rtems_fatal_error_occurred(1);
@@ -242,5 +242,5 @@
 void Clock_exit()
 {
-  pc386_remove_rtems_irq_handler (&clockIrqData);
+  BSP_remove_rtems_irq_handler (&clockIrqData);
 }
 
Index: c/src/lib/libbsp/i386/pc386/console/console.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/console/console.c	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/pc386/console/console.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -35,4 +35,6 @@
 #include <stdlib.h>
 #include <assert.h>
+#undef __assert
+void __assert (const char *file, int line, const char *msg);
 
 #include <bsp.h>
@@ -40,22 +42,25 @@
 #include <rtems/libio.h>
 #include <termios.h>
-#include <pc386uart.h>
+#include <uart.h>
 #include <libcpu/cpuModel.h>
 
 /*
  * Possible value for console input/output :
- *	PC386_CONSOLE_PORT_CONSOLE
- *	PC386_UART_COM1
- *	PC386_UART_COM2
+ *	BSP_CONSOLE_PORT_CONSOLE
+ *	BSP_UART_COM1
+ *	BSP_UART_COM2
  */
 
 /*
  * Possible value for console input/output :
- *	PC386_CONSOLE_PORT_CONSOLE
- *	PC386_UART_COM1
- *	PC386_UART_COM2
+ *	BSP_CONSOLE_PORT_CONSOLE
+ *	BSP_UART_COM1
+ *	BSP_UART_COM2
  */
 
-int PC386ConsolePort = PC386_CONSOLE_PORT_CONSOLE;
+int BSPConsolePort = BSP_CONSOLE_PORT_CONSOLE;
+
+/* int BSPConsolePort = BSP_UART_COM2;  */
+int BSPBaseBaud    = 115200;
 
 extern BSP_polling_getchar_function_type BSP_poll_char;
@@ -67,4 +72,5 @@
 extern rtems_boolean _IBMPC_scankey(char *);  /* defined in 'inch.c' */
 extern char BSP_wait_polled_input(void);
+extern void _IBMPC_initVideo(void);
 
 static int  conSetAttr(int minor, const struct termios *);
@@ -74,5 +80,5 @@
 
 
-static rtems_irq_connect_data console_isr_data = {PC_386_KEYBOARD,
+static rtems_irq_connect_data console_isr_data = {BSP_KEYBOARD,
 						   _IBMPC_keyboard_isr,
 						   isr_on,
@@ -95,26 +101,28 @@
 isr_is_on(const rtems_irq_connect_data *irq)
 {
-  return pc386_irq_enabled_at_i8259s(irq->name);
+  return BSP_irq_enabled_at_i8259s(irq->name);
 }
 
 void console_reserve_resources(rtems_configuration_table *conf)
 {
-  if(PC386ConsolePort != PC386_CONSOLE_PORT_CONSOLE)
+    if(BSPConsolePort != BSP_CONSOLE_PORT_CONSOLE)
     {
       rtems_termios_reserve_resources(conf, 1);
     }
+   
   return;
 }
 
-void __assert(const char *file, int line, const char *msg)
-{
-  static   char exit_msg[] = "EXECUTIVE SHUTDOWN! Any key to reboot...";
+void __assert (const char *file, int line, const char *msg)
+{
+    static   char exit_msg[] = "EXECUTIVE SHUTDOWN! Any key to reboot...";
   unsigned char  ch;
- 
+   
   /*
    * Note we cannot call exit or printf from here, 
    * assert can fail inside ISR too
    */
-  /*
+
+   /*
    * Close console
    */
@@ -130,4 +138,5 @@
   printk("\n\n");
   rtemsReboot();
+
 }
 
@@ -150,9 +159,9 @@
    */
 
-  if(PC386ConsolePort == PC386_CONSOLE_PORT_CONSOLE)
-    {
-
+
+  if(BSPConsolePort == BSP_CONSOLE_PORT_CONSOLE)
+    {
       /* Install keyboard interrupt handler */
-      status = pc386_install_rtems_irq_handler(&console_isr_data);
+      status = BSP_install_rtems_irq_handler(&console_isr_data);
   
       if (!status)
@@ -182,22 +191,22 @@
       
       /* 9600-8-N-1 */
-      PC386_uart_init(PC386ConsolePort, 9600, 0);
+      BSP_uart_init(BSPConsolePort, 9600, 0);
       
       
       /* Set interrupt handler */
-      if(PC386ConsolePort == PC386_UART_COM1)
-	{
-	  console_isr_data.name = PC386_UART_COM1_IRQ;
-	  console_isr_data.hdl  = PC386_uart_termios_isr_com1;
+      if(BSPConsolePort == BSP_UART_COM1)
+	{
+	  console_isr_data.name = BSP_UART_COM1_IRQ;
+	  console_isr_data.hdl  = BSP_uart_termios_isr_com1;
 	  
 	}
       else
 	{
-          assert(PC386ConsolePort == PC386_UART_COM2);
-	  console_isr_data.name = PC386_UART_COM2_IRQ;
-	  console_isr_data.hdl  = PC386_uart_termios_isr_com2;
-	}
-
-      status = pc386_install_rtems_irq_handler(&console_isr_data);
+          assert(BSPConsolePort == BSP_UART_COM2);
+	  console_isr_data.name = BSP_UART_COM2_IRQ;
+	  console_isr_data.hdl  = BSP_uart_termios_isr_com2;
+	}
+
+      status = BSP_install_rtems_irq_handler(&console_isr_data);
 
       if (!status){
@@ -215,5 +224,5 @@
 	}
 
-      if(PC386ConsolePort == PC386_UART_COM1)
+      if(BSPConsolePort == BSP_UART_COM1)
 	{
 	  printk("Initialized console on port COM1 9600-8-N-1\n\n");
@@ -230,5 +239,5 @@
        * This may be convenient to debug the serial line driver itself...
        */
-      printk("Warning : This will be the last message displayed on console\n");
+      /*      printk("Warning : This will be the last message displayed on console\n");*/
       BSP_output_char = (BSP_output_char_function_type) BSP_output_char_via_serial;
       BSP_poll_char   = (BSP_polling_getchar_function_type) BSP_poll_char_via_serial;
@@ -243,5 +252,5 @@
 static int console_last_close(int major, int minor, void *arg)
 {
-  pc386_remove_rtems_irq_handler (&console_isr_data);
+  BSP_remove_rtems_irq_handler (&console_isr_data);
 
   return 0;
@@ -262,5 +271,5 @@
     console_last_close,       /* lastClose */
     NULL,	              /* pollRead */
-    PC386_uart_termios_write_com1, /* write */
+    BSP_uart_termios_write_com1, /* write */
     conSetAttr,	              /* setAttributes */
     NULL,	              /* stopRemoteTx */
@@ -269,5 +278,5 @@
   };
 
-  if(PC386ConsolePort == PC386_CONSOLE_PORT_CONSOLE)
+  if(BSPConsolePort == BSP_CONSOLE_PORT_CONSOLE)
     {
       ++console_open_count;
@@ -275,7 +284,7 @@
     }
 
-  if(PC386ConsolePort == PC386_UART_COM2)
-    {
-      cb.write = PC386_uart_termios_write_com2;
+  if(BSPConsolePort == BSP_UART_COM2)
+    {
+      cb.write = BSP_uart_termios_write_com2;
     }
 
@@ -291,9 +300,9 @@
    * Pass data area info down to driver
    */
-  PC386_uart_termios_set(PC386ConsolePort, 
+  BSP_uart_termios_set(BSPConsolePort, 
 			 ((rtems_libio_open_close_args_t *)arg)->iop->data1);
   
   /* Enable interrupts  on channel */
-  PC386_uart_intr_ctrl(PC386ConsolePort, PC386_UART_INTR_CTRL_TERMIOS);
+  BSP_uart_intr_ctrl(BSPConsolePort, BSP_UART_INTR_CTRL_TERMIOS);
 
   return RTEMS_SUCCESSFUL;
@@ -310,5 +319,5 @@
   rtems_device_driver res = RTEMS_SUCCESSFUL;
 
-  if(PC386ConsolePort != PC386_CONSOLE_PORT_CONSOLE)
+  if(BSPConsolePort != BSP_CONSOLE_PORT_CONSOLE)
     {
       res =  rtems_termios_close (arg);
@@ -338,5 +347,5 @@
   int            count, maximum  = rw_args->count;
 
-  if(PC386ConsolePort != PC386_CONSOLE_PORT_CONSOLE)
+  if(BSPConsolePort != BSP_CONSOLE_PORT_CONSOLE)
     {
       return rtems_termios_read (arg);
@@ -383,5 +392,5 @@
   int            count, maximum  = rw_args->count;
 
-  if(PC386ConsolePort != PC386_CONSOLE_PORT_CONSOLE)
+  if(BSPConsolePort != BSP_CONSOLE_PORT_CONSOLE)
     {
       return rtems_termios_write (arg);
@@ -410,5 +419,5 @@
 )
 { 
-  if(PC386ConsolePort != PC386_CONSOLE_PORT_CONSOLE)
+  if(BSPConsolePort != BSP_CONSOLE_PORT_CONSOLE)
     {
       return rtems_termios_ioctl (arg);
@@ -482,5 +491,5 @@
     }
 
-  PC386_uart_set_baud(PC386ConsolePort, baud);
+  BSP_uart_set_baud(BSPConsolePort, baud);
 
   return 0;
Index: c/src/lib/libbsp/i386/pc386/include/bsp.h
===================================================================
--- c/src/lib/libbsp/i386/pc386/include/bsp.h	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/pc386/include/bsp.h	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -161,8 +161,8 @@
 void rtemsReboot(void);                  /* from 'exit.c'   */
 
-/* Definitions for PC386ConsolePort */
-#define PC386_CONSOLE_PORT_CONSOLE (-1)
-#define PC386_CONSOLE_PORT_COM1    (PC386_UART_COM1)
-#define PC386_CONSOLE_PORT_COM2    (PC386_UART_COM2)
+/* Definitions for BSPConsolePort */
+#define BSP_CONSOLE_PORT_CONSOLE (-1)
+#define BSP_CONSOLE_PORT_COM1    (BSP_UART_COM1)
+#define BSP_CONSOLE_PORT_COM2    (BSP_UART_COM2)
 
 /* GDB stub stuff */
Index: c/src/lib/libbsp/i386/pc386/startup/exit.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/startup/exit.c	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/pc386/startup/exit.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -36,5 +36,5 @@
 #include <bsp.h>
 #include <rtems/libio.h>
-#include <pc386uart.h>
+#include <uart.h>
 
 void bsp_cleanup(void)
Index: c/src/lib/libbsp/i386/pc386/startup/linkcmds
===================================================================
--- c/src/lib/libbsp/i386/pc386/startup/linkcmds	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/pc386/startup/linkcmds	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -63,5 +63,4 @@
     _rodata_start = . ;
     *(.rodata)
-    *(.gnu.linkonce.r*)
     _erodata = ALIGN( 0x10 ) ;
 
Index: c/src/lib/libbsp/i386/pc386/timer/timer.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/timer/timer.c	(revision 711a2a113395e4801cf82adbcb70990e5eeddc65)
+++ c/src/lib/libbsp/i386/pc386/timer/timer.c	(revision 0ebbf66b0ee518763ee38b4ac28c7d3b6feaadf1)
@@ -168,5 +168,5 @@
      * disable interrrupt at i8259 level
      */
-     pc386_irq_disable_at_i8259s(used->idtIndex - PC386_IRQ_VECTOR_BASE);
+     BSP_irq_disable_at_i8259s(used->idtIndex - BSP_IRQ_VECTOR_BASE);
      /* reset timer mode to standard (DOS) value */
      outport_byte(TIMER_MODE, TIMER_SEL0|TIMER_16BIT|TIMER_RATEGEN);
@@ -186,5 +186,5 @@
      * enable interrrupt at i8259 level
      */
-     pc386_irq_enable_at_i8259s(used->idtIndex - PC386_IRQ_VECTOR_BASE);
+     BSP_irq_enable_at_i8259s(used->idtIndex - BSP_IRQ_VECTOR_BASE);
 }
 
@@ -192,8 +192,8 @@
 timerIsOn(const rtems_raw_irq_connect_data *used)
 {
-     return pc386_irq_enabled_at_i8259s(used->idtIndex - PC386_IRQ_VECTOR_BASE);}
+     return BSP_irq_enabled_at_i8259s(used->idtIndex - BSP_IRQ_VECTOR_BASE);}
 
 static rtems_raw_irq_connect_data timer_raw_irq_data = {
-  PC_386_PERIODIC_TIMER + PC386_IRQ_VECTOR_BASE,
+  BSP_PERIODIC_TIMER + BSP_IRQ_VECTOR_BASE,
   timerisr,
   timerOn,
